-- Decode stage of the pipeline

library IEEE;
use IEEE.std_logic_1164.all;

use WORK.dlx_types.all;
use WORK.control_types_2.all;

entity decode is

  generic (tpd_fsm : Time;                            -- fsm / decoder or gate
           tpd_dec : Time;
           DEBUG : boolean := false);

 port(stall         : in std_logic;
      phi1          : in std_logic;
      instr_in      : in dlx_word;

-- shifted signals for execution stage

      mdr_ctrl    : out std_logic_vector(0 to 2);
      s1_enab_out : out std_logic_vector(0 to 5);
      s2_enab_out : out std_logic_vector(0 to 3);
      alu_op_sel_out : out std_logic_vector(0 to 3);
      dest_enab_out : out std_logic_vector(0 to 4);
      const_sel_out : out std_logic_vector(0 to 1);
      immed_sel_out : out std_logic_vector(0 to 1);
      exc_enab_out : out std_logic_vector(0 to 7);
      icr_shifter_out : out std_logic;
      iar_mux_out : out std_logic;
      iar_latch_out : out std_logic;
      smdr_latch_out : out std_logic;
      test_and_set_out : out test_and_set_instr;

-- shifted signals for memory stage

      mem_ctrl_out   : out std_logic_vector(0 to 5);
      entry_mux_out  : out std_logic;
      c_latch_out    : out std_logic;
      branch_out   : out std_logic;
      lmdr_latch_out : out std_logic;

-- shifted signals for write back stage

      wb_mux_out : out std_logic;
      rf_in_out : out std_logic;
      rd_out            : out dlx_reg_addr;

-- control signals of decode stage

      rs1_out	: out dlx_reg_addr;
      rs2_out   : out dlx_reg_addr;


      ir_1_latch : out std_logic;
-- return from fw_logic
      reg_value : in std_logic);

end decode;


